<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Coordinate Systems &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../_static/doctools.js?v=888ff710"></script>
        <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="EventDetector" href="event_detector.html" />
    <link rel="prev" title="Agent Components" href="agent_components.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            openPASS
              <img src="../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/50_scenario_simulation.html">Simulator</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="../20_simulator_advanced.html">Simulator</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="agent_components.html">Agent Components</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">Coordinate Systems</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#world-coordinate-system">World Coordinate System</a></li>
<li class="toctree-l3"><a class="reference internal" href="#road-coordinate-system">Road Coordinate System</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#agent-coordinate-system">Agent Coordinate System</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#sensor-coordinate-system">Sensor Coordinate System</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#conversions-between-sensordata-coordinate-systems">Conversions between SensorData coordinate systems</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="event_detector.html">EventDetector</a></li>
<li class="toctree-l2"><a class="reference internal" href="scenario_actions.html">Mapping of OpenSCENARIO Actions</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulation.html">Simulation</a></li>
<li class="toctree-l2"><a class="reference internal" href="spawner_features.html">Spawner Features</a></li>
<li class="toctree-l2"><a class="reference internal" href="system_structure_and_parameterization_%28SSP%29.html">System Structure and Parameterization (SSP)</a></li>
<li class="toctree-l2"><a class="reference internal" href="world_osi.html">World_OSI</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../20_simulator_advanced.html">Simulator</a></li>
      <li class="breadcrumb-item active">Coordinate Systems</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../_sources/advanced_topics/simulator/coordinate_systems.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="coordinate-systems">
<span id="coordinatesystems"></span><h1>Coordinate Systems<a class="headerlink" href="#coordinate-systems" title="Link to this heading"></a></h1>
<p><strong>openPASS</strong> uses three different coordinate systems.
All systems rotate counterclockwise and use radian.</p>
<section id="world-coordinate-system">
<span id="coordinatesystems-world"></span><h2>World Coordinate System<a class="headerlink" href="#world-coordinate-system" title="Link to this heading"></a></h2>
<p>The world coordinate system is absolute.
It is the parent coordinate system and all other systems are relative to the world coordinate system.
This system consists of <em>x</em>, <em>y</em> and <em>z</em> (<em>z</em> is currently unused).</p>
<figure class="align-default" id="id1">
<img alt="../../_images/WorldCoordinateSystem.svg" src="../../_images/WorldCoordinateSystem.svg" /><figcaption>
<p><span class="caption-text">World Coordinate System</span><a class="headerlink" href="#id1" title="Link to this image"></a></p>
</figcaption>
</figure>
</section>
<section id="road-coordinate-system">
<span id="coordinatesystems-road"></span><h2>Road Coordinate System<a class="headerlink" href="#road-coordinate-system" title="Link to this heading"></a></h2>
<p>The road coordinate system is relative to the position of the road in the world coordinate system.
It consists of <em>s</em> and <em>t</em> coordinates, where <em>s</em> describes the longitudinal position along the road.
At the beginning of the road <em>s</em> = 0, increasing with the downstream direction of the road.
The coordinate <em>t</em> describes the lateral position relative to the center of the road, where <em>t</em> &gt; 0 indicates left side and <em>t</em> &lt; 0 right side of the road with respect to the road direction.</p>
<figure class="align-default" id="id2">
<img alt="../../_images/RoadCoordinateSystem.svg" src="../../_images/RoadCoordinateSystem.svg" /><figcaption>
<p><span class="caption-text">Road Coordinate System</span><a class="headerlink" href="#id2" title="Link to this image"></a></p>
</figcaption>
</figure>
<section id="agent-coordinate-system">
<span id="coordinatesystems-agent"></span><h3>Agent Coordinate System<a class="headerlink" href="#agent-coordinate-system" title="Link to this heading"></a></h3>
<p>The agent coordinate system is relative to the position of the agent in the world coordinate system.
It uses longitudinal, lateral and height (height currently unused).
The system originates at the <em>reference point</em>, which is located at the center of the rear axle.
The longitudinal axis is parallel to the length of the car and the lateral axis is parallel to the width of the car</p>
<figure class="align-default" id="id3">
<img alt="../../_images/AgentCoordinateSystem.svg" src="../../_images/AgentCoordinateSystem.svg" /><figcaption>
<p><span class="caption-text">Agent Coordinate System</span><a class="headerlink" href="#id3" title="Link to this image"></a></p>
</figcaption>
</figure>
</section>
</section>
<section id="sensor-coordinate-system">
<span id="coordinatesystems-sensor"></span><h2>Sensor Coordinate System<a class="headerlink" href="#sensor-coordinate-system" title="Link to this heading"></a></h2>
<p>Each sensor has its own coordinate system whose origin is the mounting position of the sensor.
The <em>x</em> axis points in the direction of the sensor as defined by the mounting orientation.
All values in the OSI SensorData generated by a sensor are in its sensor coordinate system.
Vectorial values such as velocity and acceleration are relative to the own vehicle’s velocity and acceleration at the sensor position.</p>
<section id="conversions-between-sensordata-coordinate-systems">
<span id="coordinatesystems-sensor-transformation"></span><h3>Conversions between SensorData coordinate systems<a class="headerlink" href="#conversions-between-sensordata-coordinate-systems" title="Link to this heading"></a></h3>
<p>Since all values in the SensorData are relative to the sensor the following conversions are needed.</p>
<p>In the Sensor_OSI where the SensorData is written, data for other objects is calculated according to these steps:</p>
<ol class="arabic simple">
<li><p>Get position, velocity and acceleration from the SensorView in world coordinates</p></li>
<li><dl class="simple">
<dt>For the position:</dt><dd><ol class="arabic simple">
<li><p>Translation by the sensor position (in world coordinates, inverse)</p></li>
<li><p>Rotation by the sensor orientation (in world coordinates, inverse)</p></li>
</ol>
</dd>
</dl>
</li>
<li><dl class="simple">
<dt>For the velocity and acceleration (vectorial):</dt><dd><ol class="arabic simple">
<li><p>Subtract own velocity / acceleration at sensor position</p></li>
<li><p>Rotation by the sensor orientation (in world coordinates, inverse)</p></li>
</ol>
</dd>
</dl>
</li>
</ol>
<p>ADAS using SensorData may need to convert the values back to the agent coordinate system.
The SensorFusion_Errorless also converts the merged SensorData to agent coordinate and sets the mounting position to the agents reference point.
This calculation follows the following steps:</p>
<ol class="arabic simple">
<li><p>Get position, velocity and acceleration from the SensorData in sensor coordinates</p></li>
<li><dl class="simple">
<dt>For the position:</dt><dd><ol class="arabic simple">
<li><p>Rotation by the sensor orientation (mounting position in agent coordinates)</p></li>
<li><p>Translation by the sensor position (mounting position in agent coordinates)</p></li>
</ol>
</dd>
</dl>
</li>
<li><dl class="simple">
<dt>For the velocity and acceleration (vectorial):</dt><dd><ol class="arabic simple">
<li><p>Calculate the difference between the ego velocity / acceleration at the sensor position to the reference point (in world coordinates)</p></li>
<li><p>Rotation of this difference by the inverse agent orientation</p></li>
<li><p>Rotation of objects’ velocity / acceleration by the sensor orientation (mounting position in agent coordinates)</p></li>
<li><p>Add results of the two previous steps</p></li>
</ol>
</dd>
</dl>
</li>
</ol>
</section>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="agent_components.html" class="btn btn-neutral float-left" title="Agent Components" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="event_detector.html" class="btn btn-neutral float-right" title="EventDetector" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>